-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Vector Map - Palette
This demo shows how to color specific map areas using a palette. In the JavaScript VectorMap component, a palette defines a range of colors that are used to paint areas. This range is divided into segments using the value assigned to the colorGroups property. Each segment contributes a color into an array of colors.
The map in this demo represents the top 40 countries by population. Map areas are colored according to the percentage of population.
Was this demo helpful?
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
$(() => {
$('#vector-map').dxVectorMap({
bounds: [-180, 85, 180, -60],
layers: {
name: 'areas',
dataSource: DevExpress.viz.map.sources.world,
palette: 'Violet',
colorGroups: [0, 0.5, 0.8, 1, 2, 3, 100],
colorGroupingField: 'population',
customize(elements) {
$.each(elements, (_, element) => {
element.attribute('population', populations[element.attribute('name')]);
});
},
},
legends: [{
source: { layer: 'areas', grouping: 'color' },
customizeText(arg) {
let text;
if (arg.index === 0) {
text = '< 0.5%';
} else if (arg.index === 5) {
text = '> 3%';
} else {
text = `${arg.start}% to ${arg.end}%`;
}
return text;
},
}],
tooltip: {
enabled: true,
customizeTooltip(arg) {
if (arg.attribute('population')) {
return { text: `${arg.attribute('name')}: ${arg.attribute('population')}% of world population` };
}
return null;
},
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" />
<script src="js/dx.all.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/world.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/africa.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/canada.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/eurasia.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/europe.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/usa.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="vector-map"></div>
</div>
</body>
</html>
#vector-map {
height: 440px;
}
const populations = {
China: 19,
India: 17.4,
'United States': 4.44,
Indonesia: 3.45,
Brazil: 2.83,
Pakistan: 2.62,
Nigeria: 2.42,
Bangladesh: 2.18,
Russia: 2.04,
Japan: 1.77,
Mexico: 1.67,
Philippines: 1.39,
Vietnam: 1.25,
Ethiopia: 1.23,
Egypt: 1.21,
Germany: 1.13,
Iran: 1.08,
Turkey: 1.07,
'Congo (Kinshasa)': 0.94,
France: 0.92,
Thailand: 0.9,
'United Kingdom': 0.89,
Italy: 0.85,
Burma: 0.84,
'South Africa': 0.74,
'S. Korea': 0.7,
Colombia: 0.66,
Spain: 0.65,
Tanzania: 0.63,
Kenya: 0.62,
Ukraine: 0.6,
Argentina: 0.59,
Algeria: 0.54,
Poland: 0.54,
Sudan: 0.52,
Canada: 0.49,
Uganda: 0.49,
Iraq: 0.47,
Morocco: 0.46,
Uzbekistan: 0.43,
};

Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
import React from 'react';
import VectorMap, {
ILayerProps,
ILegendProps, ITooltipProps,
Layer,
Legend,
Source,
Tooltip,
} from 'devextreme-react/vector-map';
import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js';
import { populations } from './data.ts';
const colorGroups = [0, 0.5, 0.8, 1, 2, 3, 100];
const bounds = [-180, 85, 180, -60];
const customizeLayer: ILayerProps['customize'] = (elements) => {
elements.forEach((element) => {
element.attribute('population', populations[element.attribute('name')]);
});
};
const customizeText: ILegendProps['customizeText'] = (arg) => {
let text;
if (arg.index === 0) {
text = '< 0.5%';
} else if (arg.index === 5) {
text = '> 3%';
} else {
text = `${arg.start}% to ${arg.end}%`;
}
return text;
};
const customizeTooltip: ITooltipProps['customizeTooltip'] = (arg) => {
if (arg.attribute('population')) {
return { text: `${arg.attribute('name')}: ${arg.attribute('population')}% of world population` };
}
return null;
};
export default function App() {
return (
<VectorMap id="vector-map" bounds={bounds}>
<Layer
dataSource={mapsData.world}
palette="Violet"
name="areas"
colorGroupingField="population"
colorGroups={colorGroups}
customize={customizeLayer}
></Layer>
<Tooltip enabled={true} customizeTooltip={customizeTooltip}></Tooltip>
<Legend customizeText={customizeText}>
<Source layer="areas" grouping="color"></Source>
</Legend>
</VectorMap>
);
}
import React from 'react';
import VectorMap, {
Layer, Legend, Source, Tooltip,
} from 'devextreme-react/vector-map';
import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js';
import { populations } from './data.js';
const colorGroups = [0, 0.5, 0.8, 1, 2, 3, 100];
const bounds = [-180, 85, 180, -60];
const customizeLayer = (elements) => {
elements.forEach((element) => {
element.attribute('population', populations[element.attribute('name')]);
});
};
const customizeText = (arg) => {
let text;
if (arg.index === 0) {
text = '< 0.5%';
} else if (arg.index === 5) {
text = '> 3%';
} else {
text = `${arg.start}% to ${arg.end}%`;
}
return text;
};
const customizeTooltip = (arg) => {
if (arg.attribute('population')) {
return {
text: `${arg.attribute('name')}: ${arg.attribute('population')}% of world population`,
};
}
return null;
};
export default function App() {
return (
<VectorMap
id="vector-map"
bounds={bounds}
>
<Layer
dataSource={mapsData.world}
palette="Violet"
name="areas"
colorGroupingField="population"
colorGroups={colorGroups}
customize={customizeLayer}
></Layer>
<Tooltip
enabled={true}
customizeTooltip={customizeTooltip}
></Tooltip>
<Legend customizeText={customizeText}>
<Source
layer="areas"
grouping="color"
></Source>
</Legend>
</VectorMap>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const populations = {
China: 19,
India: 17.4,
'United States': 4.44,
Indonesia: 3.45,
Brazil: 2.83,
Pakistan: 2.62,
Nigeria: 2.42,
Bangladesh: 2.18,
Russia: 2.04,
Japan: 1.77,
Mexico: 1.67,
Philippines: 1.39,
Vietnam: 1.25,
Ethiopia: 1.23,
Egypt: 1.21,
Germany: 1.13,
Iran: 1.08,
Turkey: 1.07,
'Congo (Kinshasa)': 0.94,
France: 0.92,
Thailand: 0.9,
'United Kingdom': 0.89,
Italy: 0.85,
Burma: 0.84,
'South Africa': 0.74,
'S. Korea': 0.7,
Colombia: 0.66,
Spain: 0.65,
Tanzania: 0.63,
Kenya: 0.62,
Ukraine: 0.6,
Argentina: 0.59,
Algeria: 0.54,
Poland: 0.54,
Sudan: 0.52,
Canada: 0.49,
Uganda: 0.49,
Iraq: 0.47,
Morocco: 0.46,
Uzbekistan: 0.43,
};
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-dist/js/vectormap-data/*': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'devextreme-dist/js/vectormap-data': '../../../../js/vectormap-data',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@24.2.7/cjs',
'devextreme-react': 'npm:devextreme-react@24.2.7/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.16/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.60/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const populations = {
China: 19,
India: 17.4,
'United States': 4.44,
Indonesia: 3.45,
Brazil: 2.83,
Pakistan: 2.62,
Nigeria: 2.42,
Bangladesh: 2.18,
Russia: 2.04,
Japan: 1.77,
Mexico: 1.67,
Philippines: 1.39,
Vietnam: 1.25,
Ethiopia: 1.23,
Egypt: 1.21,
Germany: 1.13,
Iran: 1.08,
Turkey: 1.07,
'Congo (Kinshasa)': 0.94,
France: 0.92,
Thailand: 0.9,
'United Kingdom': 0.89,
Italy: 0.85,
Burma: 0.84,
'South Africa': 0.74,
'S. Korea': 0.7,
Colombia: 0.66,
Spain: 0.65,
Tanzania: 0.63,
Kenya: 0.62,
Ukraine: 0.6,
Argentina: 0.59,
Algeria: 0.54,
Poland: 0.54,
Sudan: 0.52,
Canada: 0.49,
Uganda: 0.49,
Iraq: 0.47,
Morocco: 0.46,
Uzbekistan: 0.43,
};
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#vector-map {
height: 440px;
}

Palette
Documentation
This demo shows how to color specific map areas using a palette. In the VectorMap component, a palette defines a range of colors that are used to paint areas. This range is divided into segments using the value assigned to the colorGroups property. Each segment contributes a color into an array of colors.
The map in this demo represents the top 40 countries by population. Map areas are colored according to the percentage of population.
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
<template>
<DxVectorMap
id="vector-map"
:bounds="bounds"
>
<DxLayer
:data-source="mapsWorld"
:color-groups="colorGroups"
:customize="customizeLayer"
palette="Violet"
name="areas"
color-grouping-field="population"
/>
<DxLegend
:customize-text="customizeText"
>
<DxSource
layer="areas"
grouping="color"
/>
</DxLegend>
</DxVectorMap>
</template>
<script>
import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js';
import {
DxVectorMap,
DxLayer,
DxLegend,
DxSource,
} from 'devextreme-vue/vector-map';
import { populations } from './data.js';
export default {
components: {
DxVectorMap,
DxLayer,
DxLegend,
DxSource,
},
data() {
return {
mapsWorld: mapsData.world,
bounds: [-180, 85, 180, -60],
colorGroups: [0, 0.5, 0.8, 1, 2, 3, 100],
};
},
methods: {
customizeLayer(elements) {
elements.forEach((element) => {
element.attribute('population', populations[element.attribute('name')]);
});
},
customizeText(itemInfo) {
let text;
if (itemInfo.index === 0) {
text = '< 0.5%';
} else if (itemInfo.index === 5) {
text = '> 3%';
} else {
text = `${itemInfo.start}% to ${itemInfo.end}%`;
}
return text;
},
},
};
</script>
<style>
#vector-map {
height: 440px;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
export const populations = {
China: 19,
India: 17.4,
'United States': 4.44,
Indonesia: 3.45,
Brazil: 2.83,
Pakistan: 2.62,
Nigeria: 2.42,
Bangladesh: 2.18,
Russia: 2.04,
Japan: 1.77,
Mexico: 1.67,
Philippines: 1.39,
Vietnam: 1.25,
Ethiopia: 1.23,
Egypt: 1.21,
Germany: 1.13,
Iran: 1.08,
Turkey: 1.07,
'Congo (Kinshasa)': 0.94,
France: 0.92,
Thailand: 0.9,
'United Kingdom': 0.89,
Italy: 0.85,
Burma: 0.84,
'South Africa': 0.74,
'S. Korea': 0.7,
Colombia: 0.66,
Spain: 0.65,
Tanzania: 0.63,
Kenya: 0.62,
Ukraine: 0.6,
Argentina: 0.59,
Algeria: 0.54,
Poland: 0.54,
Sudan: 0.52,
Canada: 0.49,
Uganda: 0.49,
Iraq: 0.47,
Morocco: 0.46,
Uzbekistan: 0.43,
};
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme-dist/js/vectormap-data/*': {
'esModule': true,
},
},
paths: {
'root:': '../../../../../',
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.3.4/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js',
'demo-ts-loader': 'root:utils/demo-ts-loader.js',
'svg-loader': 'root:utils/svg-loader.js',
'devextreme-dist/js/vectormap-data': 'npm:devextreme-dist@23.1.6/js/vectormap-data',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme-vue': 'npm:devextreme-vue@23.1.6',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
<dx-vector-map id="vector-map" [bounds]="[-180, 85, 180, -60]">
<dxo-tooltip
[enabled]="true"
[customizeTooltip]="customizeTooltip"
></dxo-tooltip>
<dxi-layer
name="areas"
palette="Violet"
colorGroupingField="population"
[colorGroups]="[0, 0.5, 0.8, 1, 2, 3, 100]"
[dataSource]="worldMap"
[customize]="customizeLayers"
></dxi-layer>
<dxi-legend [customizeText]="customizeText">
<dxo-source layer="areas" grouping="color"></dxo-source>
</dxi-legend>
</dx-vector-map>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxVectorMapModule } from 'devextreme-angular';
import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js';
import { Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
})
export class AppComponent {
worldMap = mapsData.world;
populations: Object;
constructor(service: Service) {
this.populations = service.getPopulations();
this.customizeLayers = this.customizeLayers.bind(this);
}
customizeTooltip({ attribute }: { attribute: Function }) {
if (attribute('population')) {
return {
text: `${attribute('name')}: ${attribute('population')}% of world population`,
};
}
}
customizeLayers(elements: { attribute: Function }[]) {
elements.forEach((element) => {
element.attribute('population', this.populations[element.attribute('name')]);
});
}
customizeText({ index, start, end }: Record<string, number>) {
let text = (index === 0) ? '< 0.5%' : `${start}% to ${end}%`;
return (index === 5) ? '> 3%' : text;
}
}
@NgModule({
imports: [
BrowserModule,
DxVectorMapModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #vector-map {
height: 440px;
}
import { Injectable } from '@angular/core';
const populations: Object = {
China: 19,
India: 17.4,
'United States': 4.44,
Indonesia: 3.45,
Brazil: 2.83,
Pakistan: 2.62,
Nigeria: 2.42,
Bangladesh: 2.18,
Russia: 2.04,
Japan: 1.77,
Mexico: 1.67,
Philippines: 1.39,
Vietnam: 1.25,
Ethiopia: 1.23,
Egypt: 1.21,
Germany: 1.13,
Iran: 1.08,
Turkey: 1.07,
'Congo (Kinshasa)': 0.94,
France: 0.92,
Thailand: 0.9,
'United Kingdom': 0.89,
Italy: 0.85,
Burma: 0.84,
'South Africa': 0.74,
'S. Korea': 0.7,
Colombia: 0.66,
Spain: 0.65,
Tanzania: 0.63,
Kenya: 0.62,
Ukraine: 0.6,
Argentina: 0.59,
Algeria: 0.54,
Poland: 0.54,
Sudan: 0.52,
Canada: 0.49,
Uganda: 0.49,
Iraq: 0.47,
Morocco: 0.46,
Uzbekistan: 0.43,
};
@Injectable()
export class Service {
getPopulations(): Object {
return populations;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speed-dial-action',
'splitter',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme-dist/js/vectormap-data/*': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@24.2.7/cjs',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'devextreme/bundles/dx.all': 'npm:devextreme@24.2.7/bundles/dx.all.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.16',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.60',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'devextreme-dist/js/vectormap-data': '../../../../js/vectormap-data',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.16/package.json',
'npm:devexpress-gantt@4.1.60/package.json',
],
};
System.config(window.config);
// System.import('@angular/compiler').catch(console.error.bind(console));
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.2.7/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.14.10/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>